-- name: [CS] Mlops' Yoshi
-- description: This Character Select pack adds my version of a playable yoshi from the Mario series!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_MLOPSYOSHI = smlua_model_util_get_id("mlopsyoshi_playchar_geo")

local TEX_MLOPSYOSHI = get_texture_info("mlopsyoshi-icon")

local TEXT_MOD_NAME = "[CS] Mlops' Yoshi"

local PALETTE_MLOPSYOSHI = {
    [PANTS]  = {r = 0xff, g = 0x00, b = 0x00},
    [SHIRT]  = {r = 0x4a, g = 0xff, b = 0x20},
    [GLOVES] = {r = 0xff, g = 0xff, b = 0xff},
    [SHOES]  = {r = 0xff, g = 0x00, b = 0x00},
    [HAIR]   = {r = 0xff, g = 0x00, b = 0x00},
    [SKIN]   = {r = 0xff, g = 0xde, b = 0x39},
    [CAP]    = {r = 0x8b, g = 0x00, b = 0x00},
}

local VOICETABLE_MLOPSYOSHI = {
    [CHAR_SOUND_DOH] = 'Jump_Take_1.mp3',
    [CHAR_SOUND_DYING] = 'Falling_Take_1.mp3',
    [CHAR_SOUND_GAME_OVER] = 'Falling_Take_2.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Wa_Take_1.mp3',
    [CHAR_SOUND_HAHA] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_HAHA_2] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_HELLO] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_HOOHOO] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'Sleeping_Take_1.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Long_Jump_Take_3.mp3',
    [CHAR_SOUND_OKEY_DOKEY] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_ON_FIRE] = 'Falling_Take_1.mp3',
    [CHAR_SOUND_PANTING] = 'Sleeping_Laying_down_Take_1.mp3',
    [CHAR_SOUND_PANTING_COLD] = 'Sleeping_Take_1.ogg',
    [CHAR_SOUND_PRESS_START_TO_PLAY] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_SNORING1] = 'Sleeping_Take_1.ogg',
    [CHAR_SOUND_SNORING2] = 'Sleeping_Laying_down_Take_1.mp3',
    [CHAR_SOUND_SNORING3] = {'Sleeping_Take_1.ogg', 'Sleeping_Laying_down_Take_1.mp3', 'Sleep_Talking_Take_1.mp3'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'So_long_Bowser_Take_1.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_UH] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_UH2] = 'Jump3_Take1.ogg',
    [CHAR_SOUND_UH2_2] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'Falling_Take_2.mp3',
    [CHAR_SOUND_WAH2] = 'Jump3_Take1.ogg',
    [CHAR_SOUND_WHOA] = 'DoubleJumpTake1.mp3',
    [CHAR_SOUND_YAHOO] = 'Stand_after_Triple_Jump_Take_1.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Stand_after_Triple_Jump_Take_1.mp3', 'Stand_after_Triple_Jump_Take_1.mp3', 'Jump3_Take1.ogg', 'Stand_after_Triple_Jump_Take_1.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'DoubleJumpTake1.mp3', 'Jump_Take_1.mp3', 'Jump3_Take1.ogg'},
    [CHAR_SOUND_YAWNING] = 'Falling_Asleep_Take_1.mp3',
}



local CAPTABLE_MLOPSYOSHI = {
    normal = smlua_model_util_get_id("mlopsyoshis_cap_geo"),
    wing = smlua_model_util_get_id("mlopsyoshis_wing_cap_geo"),
    metal = smlua_model_util_get_id("mlopsyoshis_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mlopsyoshis_winged_metal_cap_geo"),
}

if _G.charSelectExists then
    _G.CT_MLOPSYOSHI = _G.charSelect.character_add("Mlops' Yoshi", {"A green dino who debutted in", "1990, Trying to save his friends in", "Super Mario World!"}, "Yoshi", {r = 74, g = 255, b = 32}, E_MODEL_MLOPSYOSHI, CT_MARIO, TEX_MLOPSYOSHI)
    _G.charSelect.character_add_caps(E_MODEL_MLOPSYOSHI, CAPTABLE_MLOPSYOSHI)

    _G.charSelect.character_add_voice(E_MODEL_MLOPSYOSHI, VOICETABLE_MLOPSYOSHI)

    _G.charSelect.character_add_palette_preset(E_MODEL_MLOPSYOSHI, PALETTE_MLOPSYOSHI)

    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MLOPSYOSHI then return _G.charSelect.voice.sound(m, sound) end
    end)

    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MLOPSYOSHI then return _G.charSelect.voice.snore(m) end
    end)

else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end